#!/bin/bash

# 当前脚本版本号
current_version="V1.4"

# 输出kxy大字样
echo "
 K   K   X   X   Y   Y
 K  K     X X     Y Y
 KKK      X       Y
 K  K     X X     Y Y
 K   K   X   X    Y
"

# 输出脚本地址
echo "脚本地址： https://cdn.kuxueyun.com/script/kxy.sh"
echo "============================================="
echo "当前脚本版本: $current_version"
echo "============================================="

# 执行系统更新命令
echo "执行系统更新..."
apt update -y > /dev/null 2>&1 && apt install wget curl jq bc netcat-openbsd dnsutils iproute2 -y > /dev/null 2>&1

# 自动运行更新脚本
echo "正在检查更新..."
# 获取并下载最新版本的脚本
wget -qO "$PWD/kxy_new.sh" https://cdn.kuxueyun.com/script/kxy.sh && chmod +x "$PWD/kxy_new.sh"

# 获取新脚本的版本号
new_version=$(grep '^current_version="' "$PWD/kxy_new.sh" | cut -d'"' -f2)

# 比较版本号，如果新版本不同，则更新
if [ "$new_version" != "$current_version" ]; then
    mv "$PWD/kxy_new.sh" "$PWD/kxy.sh"
    echo "已更新至新版本: $new_version"
    echo "正在重新启动新版本的脚本..."
    exec "$PWD/kxy.sh"
else
    echo "已是最新版，无需更新。"
    rm "$PWD/kxy_new.sh"
fi

# 主菜单函数
function main_menu() {
  echo "请选择一个操作选项："
  echo "1) 开启 BBR"
  echo "2) 安装 Multi-EasyGost 转发脚本"
  echo "3) 运行 酷雪云9929 IPV6一键脚本（添加或者恢复）"
  echo "4) 运行 bench.sh 测试脚本"
  echo "5) 运行 nws.sh 测试脚本"  
  echo "6) 运行 yabs 测试脚本"
  echo "7) 运行 融合怪 测试脚本"
  echo "8) 运行 warp 一键脚本"
  echo "9) 运行 LXC 重装脚本"
  echo "10) 安装 nexttrace"
  echo "11) 下载 leitbogior 一键重装脚本"
  echo "12) 运行IPQuality脚本"  
  # 更新选项已取消
  echo "13) 退出"
  echo "============================================="
}

# 显示主菜单并读取选项
while true; do
  main_menu
  # 读取用户输入的选项
  read -p "请输入选项编号: " option

    case $option in
    1)
      echo "开启BBR..."

      # 检查 sysctl.conf 文件中是否已经存在 BBR 参数
      if ! grep -q "net.core.default_qdisc=fq" /etc/sysctl.conf; then
          echo "net.core.default_qdisc=fq" >> /etc/sysctl.conf
      fi

      if ! grep -q "net.ipv4.tcp_congestion_control=bbr" /etc/sysctl.conf; then
          echo "net.ipv4.tcp_congestion_control=bbr" >> /etc/sysctl.conf
      fi

      # 执行 sysctl -p 使设置生效
      sysctl -p
      ;;

    
    2)
      echo "下载安装并运行gost脚本..."
      wget -qO gost.sh https://cdn.kuxueyun.com/script/Multi-EasyGost/gost.sh
      chmod +x gost.sh
      ./gost.sh
      ;;
    
    3)
      echo "为支持IPV6的联通9929机型配置双IPV6地址"
      wget -qO /tmp/setup_ipv6.sh https://cdn.kuxueyun.com/script/Single/setup_ipv6.sh
      chmod +x /tmp/setup_ipv6.sh
      /tmp/setup_ipv6.sh
      rm /tmp/setup_ipv6.sh
      ;;
    
    4)
      echo "执行bench.sh加速后的脚本..."
      wget -qO- https://cdn.kuxueyun.com/script/bench-sh/bench.sh | bash
      ;;

    5)
      echo "执行nws.sh加速后的脚本..."
      wget -qO- https://cdn.kuxueyun.com/script/Single/nws.sh | bash
      ;;
    
    6)
      echo "执行yabs测试脚本，以下是操作说明："
      echo "  1) 运行默认测试: bash -s"
      echo "  2) 禁用网络测试: bash -s -- -i"
      echo "  3) 禁用硬盘测试: bash -s -- -f"
      echo "  4) 禁用网络和硬盘测试: bash -s -- -fi"
      echo "  5) 同时测试Geekbench 5和6: bash -s -- -56"
      echo "  6) 同时测试Geekbench 5和6并禁用网络测试: bash -s -- -i56"
      # 让用户选择运行的选项
      read -p "请输入你选择的选项编号（1-6）: " yabs_option
      
      case $yabs_option in
        1)
          wget -qO- https://cdn.kuxueyun.com/script/yabs/yabs.sh | bash
          ;;
        2)
          wget -qO- https://cdn.kuxueyun.com/script/yabs/yabs.sh | bash -s -- -i
          ;;
        3)
          wget -qO- https://cdn.kuxueyun.com/script/yabs/yabs.sh | bash -s -- -f
          ;;
        4)
          wget -qO- https://cdn.kuxueyun.com/script/yabs/yabs.sh | bash -s -- -fi
          ;;
        5)
          wget -qO- https://cdn.kuxueyun.com/script/yabs/yabs.sh | bash -s -- -56
          ;;
        6)
          wget -qO- https://cdn.kuxueyun.com/script/yabs/yabs.sh | bash -s -- -i56
          ;;          
        *)
          echo "无效的选项，请重新选择。"
          ;;
      esac
      ;;
    
    7)
      echo "执行融合怪脚本..."
      curl -L https://gitlab.com/spiritysdx/za/-/raw/main/ecs.sh -o ecs.sh && chmod +x ecs.sh && bash ecs.sh
      ;;
    
    8)
      echo "执行warp脚本..."
      wget -N https://gitlab.com/fscarmen/warp/-/raw/main/menu.sh && bash menu.sh [option] [lisence/url/token]
      ;;
    
    9)
      echo "执行LXC重装脚本..."
      wget -qO /tmp/OsMutation.sh https://cdn.kuxueyun.com/script/OsMutation.sh
      chmod u+x /tmp/OsMutation.sh
      /tmp/OsMutation.sh
      rm /tmp/OsMutation.sh
      ;;
    
    10)
      echo "安装nexttrace..."
      bash <(curl -Ls https://cdn.kuxueyun.com/script/nt_install.sh)
      ;;
    
    11)
      echo "下载kvm重装脚本，使用参考 bash InstallNET.sh -debian 12 进行重装..."
      wget --no-check-certificate -qO InstallNET.sh 'https://cdn.kuxueyun.com/script/InstallNET.sh' && chmod a+x InstallNET.sh
      ;;
      
    12)
      echo "执行IPQuality脚本..."
      bash <(curl -Ls IP.Check.Place)
      ;;
    
    # 更新选项已取消
    # 13)
    #   echo "更新脚本..."
    #   # 获取并下载最新版本的脚本
    #   wget -qO "$PWD/kxy_new.sh" https://cdn.kuxueyun.com/script/kxy.sh && chmod +x "$PWD/kxy_new.sh"

    #   # 替换当前脚本并执行新的脚本
    #   mv "$PWD/kxy_new.sh" "$PWD/kxy.sh"
    #   echo "已更新至新版本: $new_version"
    #   echo "正在重新启动新版本的脚本..."
    #   exec "$PWD/kxy.sh"
    #   ;;

    
    13)
      echo "退出脚本"
      exit 0
      ;;
    
    *)
      echo "无效选项，请重新选择有效的选项，或输入13退出。"
      ;;
  esac

  # 返回主菜单
  read -p "按回车键返回主菜单..."
done
